!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Program for extraction of hourly surface-layer parameters from...!!!
!!! Meteograms Files (Last Updated: DBS - September 10, 2021)        !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	Character(len=100) :: cyear, cmm, cdd, chhi, cfilename, chha 
	Character(len=100) :: cfilename2, cfilename3, ccheck1, ccheck2

	Real, Dimension(73)	:: ps, dpsdt, shfl, alhfl, qv_s, t_g,  &
        t2m, td2m, tmin2m, tmax2m, sobt, thbt, sobs, thbs, total_precr,&
        total_preca, clch, clcm, clcl, clct, vbmax10m, umfl, vmfl,     &
        rain_gspr, rain_gspa, rain_conr, rain_cona,                    &
        snow_gspr, snow_gspa, snow_conr, snow_cona, u10m, v10m,        &
        swdirs, swdifds, swdifus, pabs, albedo 

	Data ccheck1 /'Actual'/

	d_r = 3.14159265359/180.0
	r_d = 180.0/3.14159265359

	Open (1, file = 'SAMPLE-METEOGRAM', form='formatted')

	Read (1, 10) i1, j1, cdd, cmm, cyear, chhi
 10	Format (55x, i6, 6x, i6, /, 23x, a2, 1x, a2, 1x, & 
        a4, 2x, a2, 7(/))

	Write (*, *) 'Grid Number (i,j) = ', i1, j1
	Write (*, *) 'Date            = ', cdd
	Write (*, *) 'Month           = ', cmm
	Write (*, *) 'Year            = ', cyear
	Write (*, *) 'Hour            = ', chhi
	Write (*, *) 

	Write (cfilename3, 3) cdd, cmm, cyear, chhi, i1, j1 
 3	Format ('Profiles-', a2,'-', a2, '-', a4, '-', a2, 2('-', i3.3), '.dat')

	Open (3, file = cfilename3, form='formatted')
	Open (4, file = 'INPUT-PROFILE.dat', form='formatted')

	Write (3, 14) 'JTIME', 'HEIGHT', 'K', 'PMAIN', 'T', 'QV', 'REL_HUM', &
        'U', 'V', 'SPEED', 'WD', 'PLCL'
	Write (4, 14) 'JTIME', 'HEIGHT', 'K', 'PMAIN', 'T', 'QV', 'REL_HUM', &
        'U', 'V', 'SPEED', 'WD', 'PLCL'

	Do ihour = 1, 72

	ifilename = ihour + 100

	Read (1, 11, end=100) ccheck2, chha
 11	Format (6x, a6, 53x, a5, 5(/))

	If (ccheck2.ne.ccheck1) Print *, ihour, ccheck2, chha
	If (ccheck2.ne.ccheck1) Print *, 'THERE WAS SOME PROBLEM'
	If (ccheck2.ne.ccheck1) Print *, 'PLEASE RE-CHECK INPUT FILE'

	Read (chha, 12) ihha
 12	Format (i2)

	Write (cfilename, 13) i1, j1, cyear, cmm, cdd, chhi, ihha
 13	Format ('./Profiles/', i3.3,'-', i3.3, '-', a4, 3('-', a2), '+', i2.2, '.dat')

	Read (cyear, '(i4)') iyear
	xyear = float (iyear)

	Read (cmm, 12) imonth
	xmonth = float(imonth)

	Read (cdd, 12) idate
	xdate = float(idate)

	Open (ifilename, file = cfilename, form = 'formatted')

	Write (ifilename, 14) 'K', 'PMAIN', 'T', 'QV', 'QC', 'QI', 'REL_HUM',  &
			      'CLC', 'CLC_CON', 'U', 'V', 'SPEED', 'WD', 'HML',&
                              'JTIME' 
 14	Format (30(1x, a10))

	xhour = float(ihour-1)

	jday = ical2jul(idate, imonth, iyear)
	xjtime = float(jday) + (xhour/24.0)

	Do ilev = 1, 50

 101	Continue
	Read (1, 501, err=101, end=110) k, pmain, t, qv, qc, qi, rel_hum, clc, &
        clc_con, u, v, speed, hml
 501	Format (i3, f8.2, f7.2, f8.3, f8.3, f8.3, f8.2, f8.2, f8.2, f8.2, f8.2, &
        f8.2, f9.1)

	wd = (atan2(u,v) * r_d) + 180.0

	Write (ifilename, 15) k, pmain, t, qv, qc, qi, rel_hum, clc, &
                              clc_con, u, v, speed, wd, hml, xjtime
 15	Format (1x, i10, 30(1x, f10.2))

	plcl1 = plcl(t, rel_hum, pmain)

	Write (3, 16) xjtime, hml, k, pmain, t, qv, rel_hum, u, v, speed, wd, plcl1
	Write (4, 16) xjtime, hml, k, pmain, t, qv, rel_hum, u, v, speed, wd, plcl1
 16	Format (2(1x, f10.3), 1x, i10, 10(1x, f10.2))

	Enddo

	Close(ifilename)

	Read (1, 17)
 17	Format (104(/))

 110	Continue

	Enddo
	
	Write (cfilename2, 5) cdd, cmm, cyear, chhi, i1, j1
 5	Format ('Time-Series-', 2(a2, '-'), a4, '-', a2, 2('-', i3.3), '.dat')

	Open (2, file = cfilename2, form='formatted')

	Write (2, 111) 'JTIME', 'DATE', 'MONTH', 'YEAR', 'HOUR',        &
        'STIME', 'SOBT', 'THBT', 'SOBS', 'THBS', 'SHFL', 'LHFL',        &
        'QV_S', 'T2M', 'RH2M', 'U10', 'V10', 'WS10', 'WD10', 'WSMAX',   &
        'PS', 'PRECRATE', 'PRECAMT'                
 111	Format (1x, a10, 4(1x, a6), 1x, a10, 30(1x, a8)) 

	Open (11, file = 'PS.txt', form='formatted')
	Open (12, file = 'SHFL.txt', form='formatted')
	Open (13, file = 'LHFL.txt', form='formatted')
	Open (14, file = 'QV_S.txt', form='formatted')
	Open (15, file = 'T_G.txt', form='formatted')
	Open (16, file = 'T2M.txt', form='formatted')
	Open (17, file = 'TD2M.txt', form='formatted')
	Open (18, file = 'TMIN2M.txt', form='formatted')
	Open (19, file = 'TMAX2M.txt', form='formatted')
	Open (20, file = 'SOBT.txt', form='formatted')
	Open (21, file = 'SOBS.txt', form='formatted')
	Open (22, file = 'CLCH.txt', form='formatted')
	Open (23, file = 'CLCM.txt', form='formatted')
	Open (24, file = 'CLCL.txt', form='formatted')
	Open (25, file = 'CLCT.txt', form='formatted')
	Open (26, file = 'TOTAL.txt', form='formatted')
	Open (27, file = 'SWDIRS.txt', form='formatted')
	Open (28, file = 'SWDIFDS.txt', form='formatted')
	Open (29, file = 'SWDIFUS.txt', form='formatted')
	Open (30, file = 'PABS.txt', form='formatted')

	Do ihour = 1, 73

	xhour = float(ihour-1)

	ires = xhour/24
	yhour = xhour - (ires*24)

	jday = ical2jul(idate, imonth, iyear)
	xjtime = float(jday)  + (xhour/24.0)
	sjtime = float(idate) + (xhour/24.0)

	Read (11, 211, end=120) ps(ihour), dpsdt(ihour)
 211	Format (12x, f7.1, 17x, f7.1)

	Read (12, 212, end=120) shfl(ihour), umfl(ihour)
	Read (13, 212, end=120) alhfl(ihour), vmfl(ihour)
	Read (14, 212, end=120) qv_s(ihour) 
	Read (15, 212, end=120) t_g(ihour) 
	Read (16, 212, end=120) t2m(ihour), u10m(ihour) 
	Read (17, 212, end=120) td2m(ihour), v10m(ihour) 
	Read (18, 212, end=120) tmin2m(ihour), vbmax10m(ihour) 
	Read (19, 212, end=120) tmax2m(ihour)
	Read (20, 212, end=120) sobt(ihour), thbt(ihour) 
	Read (21, 212, end=120) sobs(ihour), thbs(ihour) 
 212	Format (38x, f11.3, 39x, f11.3)

	ws10 = ws(u10m(ihour), v10m(ihour))
	wd10 = (atan2(u10m(ihour),v10m(ihour)) * r_d) + 180.0
	relhum = rh (ps(ihour), qv_s(ihour), t2m(ihour))

	Read (22, 221, end=120) rain_gspr(ihour), rain_gspa(ihour), clch(ihour)
	Read (23, 221, end=120) snow_gspr(ihour), snow_gspa(ihour), clcm(ihour)
	Read (24, 221, end=120) rain_conr(ihour), rain_cona(ihour), clcl(ihour)
	Read (25, 221, end=120) snow_conr(ihour), snow_cona(ihour), clct(ihour)
	Read (26, 221, end=120) total_precr(ihour), total_preca(ihour) 
	Read (27, 212, end=120) swdirs(ihour)
	Read (28, 212, end=120) swdifds(ihour)
	Read (29, 212, end=120) swdifus(ihour)
	Read (30, 212, end=120) pabs(ihour), albedo(ihour)
 221	Format (18x, f11.3, 6x, f11.3, 26x, f11.3)

	Write (2, 51) xjtime, xdate, xmonth, xyear, yhour, sjtime,      &
        sobt(ihour), thbt(ihour), sobs(ihour), thbs(ihour), shfl(ihour),&
        alhfl(ihour), qv_s(ihour), t2m(ihour), relhum, u10m(ihour),     &
        v10m(ihour), ws10, wd10, vbmax10m(ihour), ps(ihour),            &
        total_precr(ihour), total_preca(ihour)
 51	Format (1x, f10.3, 4(1x, f6.1), 1x, f10.3, 30(1x, f8.2)) 

 120	Continue

	Enddo

 100	Stop

	End

!!! Calendar to Julian day conversion
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Function for conversion of Calendar to Julian Day Number         !!!
!!! Inputs:                                                          !!!           
!!!             Date                            (idd, integer)       !!!
!!!             Month                           (imo, integer)       !!!
!!!             Year                            (iyy, integer)       !!!      
!!! Output:                                                          !!!
!!!             Julian Day Number               (jday, integer)      !!!
!!! Version: February 16, 2010 (ATJ).                                !!!      
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
         Integer Function ical2jul(iddd,immm,iyyy)
         ! iddd  = date  (Can be anything between 1 to 31)
         ! immm  = month (Can be anything between 1 to 12)
         ! iyyy  = year  (Can be literally anything)
         ! jday  = julian day number (Can be anything between 1 to 366)
         
         Dimension incmon(13), leapinc(13)
 
         Data incmon /0, 31, 59, 90, 120, 151, 181, 212, &
      &                    243, 273, 304, 334, 365/

         Data leapinc /0, 31, 60, 91, 121, 152, 182, 213,&
      &                    244, 274, 305, 335, 366/
 
         icheck = mod (iyyy, 4) ! icheck is leap year checking index
 
         If (icheck /= 0) julday = iddd + incmon(immm)
         If (icheck == 0) julday = iddd + leapinc(immm)
 
         ical2jul = julday
 
         End Function ical2jul


!!!  Lifting Condensation Level Pressure  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Function for estimation of pressure at LCL                       !!!
!!! Inputs:                                                          !!!           
!!!             temperature                     (t, deg.C)           !!!
!!!             relative humidity               (rh, %)              !!!
!!!             pressure                        (p, hPa)             !!!      
!!! Output:                                                          !!!
!!!             temperature at LCL              (plcl, hPa)          !!!
!!! Version: February 09, 2010 (DBS).                                !!!      
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


         Real Function plcl(t,rh,p)
 
         tk      =       t + 273.15
         term1d  =       1.0/(tk - 55.0)
         term2d  =       log(rh/100.0)/2840.0
         tlcl    =       55.0 + (1.0/(term1d-term2d))
         plcl    =       p * ((tlcl/tk)**3.5)
 
         End Function plcl

!!! (20) u&v component to ws conversion
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Function for conversion of u & v component to ws conversion      !!!
!!! Inputs:                                                          !!!
!!!             u component                     (u,m/s)              !!!           
!!!             v component            		(v, m/s)             !!!
!!!Outputs:                                                          !!!
!!!             wind speed                       (ws,m/s)            !!!
!!! Version: February 22, 2010 (ATJ).                                !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!      
          Real function ws(u,v)

          r_d = 180.0/3.14159265359       ! radian to degree conversion
          d_r = 3.14159265359/180.0       ! degree to radian conversion
          ws = sqrt ( (u*u) + (v*v) )

          End function ws

!!! (20) u&v component to wd conversion
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Function for conversion of u & v component to ws conversion      !!!
!!! Inputs:                                                          !!!
!!!             u component                     (u,m/s)              !!!           
!!!             v component            		(v, m/s)             !!!
!!!Outputs:                                                          !!!
!!!             wind direction                   (wd,degree)         !!!
!!! Version: February 22, 2010 (ATJ).                                !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!      

          Real function wd(u,v)

          r_d = 180.0/3.14159265359       ! radian to degree conversion
          d_r = 3.14159265359/180.0       ! degree to radian conversion
          wd = ( atan2(u,v) * r_d ) + 180.0

          End function wd

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Function for estimation of relative humidity from p, q and t     !!!
!!! DBS (September 10, 2021)					     !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	Real Function rh(p, q, t)

	! Reference: 

	term1	=	t+243.5
	term2	= 	17.67*t
	esat1	=	6.112 * exp (term2/term1)

	term3 = 0.62197 * 1000.0
	term4 = 0.378 * q

	e1 = (p*q)/(term3 + term4)

	rh = (e1/esat1)*100.0

	End Function rh

	Real Function q(p,rh,t)

	! Reference: 

	term1	=	t+243.5
	term2	= 	17.67*t
	esat1	=	6.112 * exp (term2/term1)
	e1	= 	esat1 * (rh/100.0)
	q	=	0.62197 * e1 * 1000.0 / (p - (0.378*e1))

	End Function q
